﻿package  
{
	import fl.controls.ColorPicker;
	import fl.controls.Label;
	import fl.controls.TextInput;
	import fl.events.ColorPickerEvent;
	import flash.events.Event;
	import flash.events.TextEvent;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author ...
	 */
	public class CircularGrating extends Stimulus
	{
		static private var defaultSize:uint = 80;
		
		private var radius:ParameterControl;
		
		private var redA:ParameterControl;
		private var greenA:ParameterControl;
		private var blueA:ParameterControl;

		private var redB:ParameterControl;
		private var greenB:ParameterControl;
		private var blueB:ParameterControl;
		
		
		private var amp:ParameterControl;
		private var fs:ParameterControl;
		private var ft:ParameterControl;
		

		private function paramCopy():void {
			
			radius = paramList[0];
			redA = paramList[1];
			greenA = paramList[2];
			blueA = paramList[3];
			redB = paramList[4];
			greenB = paramList[5];
			blueB = paramList[6];
			amp = paramList[7];
			fs = paramList[8];
			ft = paramList[9];
			positionX = paramList[10];
			positionY = paramList[11];
			alphaControl = paramList[12];
			rotControl = paramList[13];
			scaleXControl = paramList[14];
			scaleYControl = paramList[15];
		}

		
		public function CircularGrating(name:String, cpy:Boolean = false) 
		{
			paramList = new Array();
			paramComboBox = new MyComboBox(10, 4, onParamFocus, name + "'s parameter");

			if(!cpy) {
				paramList.push(radius = new ParameterControl(defaultRow, "r(t)", defaultSize, 0.0, 1000, this));

				paramList.push(redA = new ParameterControl(defaultRow, "red_1(t)", 255, 0.0, 255, this));
				paramList.push(greenA = new ParameterControl(defaultRow, "green_1(t)", 255, 0.0, 255, this));
				paramList.push(blueA = new ParameterControl(defaultRow, "blue_1(t)", 255, 0.0, 255, this));

				paramList.push(redB = new ParameterControl(defaultRow, "red_2(t)", 0, 0.0, 255, this));
				paramList.push(greenB = new ParameterControl(defaultRow, "green_2(t)", 0, 0.0, 255, this));
				paramList.push(blueB = new ParameterControl(defaultRow, "blue_2(t)", 0, 0.0, 255, this));

				paramList.push(amp = new ParameterControl(defaultRow, "amp(t)", 1, 0, 1, this));
				paramList.push(fs = new ParameterControl(defaultRow, "fs(t)", 10, 0, 100, this));
				paramList.push(ft = new ParameterControl(defaultRow, "ft(t)", 10, -1000, 1000, this));
			}
			
			super(name, cpy);			

			if(!cpy)
				repaint();

		}
				
		override internal function clone(i:String):void {
			
			var cpy:CircularGrating = new CircularGrating(instanceName + i, true);
			
			for each(var v:ParameterControl in paramList) {
				cpy.paramList.push(v.clone(cpy));
			}

			cpy.paramCopy();
			Main.controlPanel.instanceBox.add(cpy.instanceName);
			
			cpy.repaint();
		}
		
		private function getColor(r:uint, g:uint, b:uint):uint {
			
			return ((r << 16) | (g << 8) | b);
		}
		
		override internal function repaint():void {
			
			step();
			
			drawGrating();
		}
		
		private function drawGrating():void {
	
			var r:Number= radius.value();

			var amplitude:Number = amp.value();
			var spatioF:Number = fs.value();
			var temporalF:Number = ft.value();

			var rA:Number = redA.value() / 2;
			var gA:Number = greenA.value() / 2;
			var bA:Number = blueA.value() / 2;
			var rB:Number = redB.value() / 2;
			var gB:Number = greenB.value() / 2;
			var bB:Number = blueB.value() / 2;
			
			var rRange:Number = (rB - rA) * amplitude;
			var gRange:Number = (gB - gA) * amplitude;
			var bRange:Number = (bB - bA) * amplitude;
			

			var tmp:Number = Stimulus.t * temporalF;
			
			for (var i:Number = 0; i < 2 * Math.PI; i += 0.01 ) {
				var s:Number = spatioF * i;
				
				var color:uint = getColor(rA + rRange * Math.sin(s + tmp), gA + gRange * Math.sin(s + tmp), bA + bRange * Math.sin(s + tmp));
				drawLine(color, i, r);
			}
			
		}
		
		private function drawLine(color:uint, i:Number, r:Number):void {			
			graphics.lineStyle(1, color);
			
			graphics.moveTo(0, 0);
			graphics.lineTo(r * Math.cos(i), r * Math.sin(i));
			
		}		
	}	
}
