﻿package  
{
	import fl.controls.Button;
	import fl.controls.ComboBox;
	import fl.controls.Label;
	import fl.controls.ScrollPolicy;
	import fl.controls.TextArea;
	import fl.controls.TextInput;
	import fl.core.UIComponent;
	import flash.display.Loader;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;


	public class ControlPanel extends MyStage
	{		
		private var newButton:MyButton;
		private var addButton:MyButton;
		private var removeButton:MyButton;
		private var startButton:MyButton;

		private var newBox:MyComboBox;
		internal var instanceBox:MyComboBox;
		
		private var nameBox:NameControl;		
		
		internal var focusedObject:Stimulus;

		static internal var playSpeed:ParameterControl;
		
		internal var globalVariable:GlobalVariables;

		private var stimuusCopy:StimulusCopy;

		public function ControlPanel(rectangle:Rectangle, color:uint = 0xcccccc) 
		{
			super(color, rectangle);

			addChild(newButton = new MyButton("NEW", 160, 1, onNewClick));			
			addChild(addButton = new MyButton("ADD", 160, 4, onAddClick));
			addChild(removeButton = new MyButton("REMOVE", 160, 20, onRemoveClick));
			addChild(startButton = new MyButton("START", 160, 24, onStartClick));
			
			nameBox = new NameControl();
			
			addChild(newBox = new MyComboBox(10, 1, newStimulus, "new stimulus"));		
				for each(var v:String in Stimulus.STIMULI)
					newBox.add(v);				
			newBox.rowCount = 100;


			addChild(instanceBox = new MyComboBox(10, 20, focusInstance, "stimulus list"));
			
			playSpeed = new ParameterControl(23, "play speed (t)", 1.0, 0.0, 100.0, null);			
			playSpeed.move(135, rowToPixel(23));
			playSpeed.setSize(30);
			
			globalVariable = new GlobalVariables();
			stimuusCopy = new StimulusCopy();

		}
		
		internal function init():void {
			new MyPrompt();
			ControlPanel.playSpeed.add();
			globalVariable.add();
			stimuusCopy.init();

		}
		
		
		private function onStartClick(event:Event):void {
			
			if (startButton.label == "START") {
				
				if (globalVariable.syntaxErrorCheck())
					return;
				else if (playSpeed.syntaxErrorCheckLight()) {
					MyPrompt.write("play speed (t) contains systax error");
					return;
				}								
				else if (syntaxErrorCheck())
					return;
									
				startButton.label = "STOP";
//				playSpeed.setEnable(false);
				Main.timer.addEventListener(TimerEvent.TIMER, repaint);
				Main.timer.start();
				
				removeButton.setEnable(false);
//				instanceBox.setEnable(false);
				newBox.setEnable(false);
				
			}
			else {
				startButton.label = "START";				
				playSpeed.setEnable(true);
				Main.timer.removeEventListener(TimerEvent.TIMER, repaint);
				Main.timer.reset();

				instanceBox.setEnable(true);
				removeButton.setEnable(true);
				newBox.setEnable(true);
				
				repaint(null);
			}
		}

		
		private function repaint(event:TimerEvent):void {
			
			Stimulus.t = Main.timer.delay * Main.timer.currentCount * playSpeed.value() / 1000;
//			Stimulus.t = Main.timer.delay * Main.timer.currentCount / 1000;

			for (var i:uint = 1; i < Main.stimuliStage.numChildren; i++ ) {
				var v:Stimulus = Main.stimuliStage.getChildAt(i) as Stimulus
				v.repaint();
			}
		}
		
		
		private function newStimulus(event:Event):void {

			if (focusedObject != null )
				focusedObject.removeControl()
			
			newButton.setEnable(true);
			nameBox.add();
			
			removeButton.setEnable(false);
			instanceBox.reset();
			instanceBox.setEnable(false);
			startButton.setEnable(false);
		}
		

		private function focusInstance(event:Event):void {
			
			if (focusedObject != null)
				focusedObject.removeControl();
			
			focusedObject = Main.stimuliStage.getChildByName(instanceBox.selectedLabel) as Stimulus;
			focusedObject.addControl();
			
			MyPrompt.write("focused on " + focusedObject.instanceName);			
			
			removeButton.setEnable(true);
		}
						
		
		static internal function rowToPixel(row:uint):uint {
			return 10 + 25 * row;
		}
		
		private function onRemoveClick(event:MouseEvent):void {

			focusedObject.removeControl();

			MyPrompt.write("removed " + focusedObject.instanceName);			
			
			Main.stimuliStage.removeChild(focusedObject);
			instanceBox.removeItem(instanceBox.selectedItem);
			
			focusedObject = null;
			instanceBox.reset();		
			
			removeButton.setEnable(false);

			instanceBox.reset();
			if (instanceBox.length > 0)
				startButton.setEnable(true);
			else
				startButton.setEnable(false);			
			
		}
		
		

		
		private function onNewClick(event:MouseEvent):void {
			
			if(!nameBox.isValidText())
				return ;
			
			var newObject:Stimulus;
			
			switch(newBox.selectedIndex) {
				case Stimulus.CIRCLE:
					newObject = new MyCircle(nameBox.getName());
					break;
					
				case Stimulus.RECTANGLE:
					newObject = new MyRectangle(nameBox.getName());
					break;
					
				case Stimulus.IMAGE:
					var img:Loader = MyImage.load(nameBox.getName());
					newObject = new MyImage(nameBox.getName(), img);
					break;

				case Stimulus.GRATING:
					newObject = new Grating(nameBox.getName());
					break;

				case Stimulus.CIRCLAR_GRATING:
					newObject = new CircularGrating(nameBox.getName());
					break;
					
				case Stimulus.GAUSS:
					newObject = new Gauss(nameBox.getName());
					break;

				case Stimulus.GAUSS_FILTER:
					newObject = new GaussFilter(nameBox.getName());
					break;

				case Stimulus.GABOR:
					newObject = new Gabor(nameBox.getName());
					break;
					
				case -1:
					MyPrompt.write("select a stimuli");
					break;
				default:
					MyPrompt.write("not inpremented yet");
			}
			
			nameBox.setEnable(false);
			
			addButton.setEnable(true);
			newButton.setEnable(false);
			newBox.setEnable(false);

			focusedObject = newObject;				
			
			newObject.addControl();
								
			MyPrompt.write("editting new " + newBox.selectedLabel + " stimulus properties");

			
		}
		
		
		
		
		internal function syntaxErrorCheck():Boolean {

			for (var i:uint = 1; i < Main.stimuliStage.numChildren; i++) {
				var v:Stimulus = Main.stimuliStage.getChildAt(i) as Stimulus;
				if (v.syntaxErrorCheck())
					return true;
			}
							
			return false;
					
		}

		
		private function onAddClick(event:MouseEvent):void {

			if (globalVariable.syntaxErrorCheck())
				return;
			else if (focusedObject.syntaxErrorCheck())
				return;

			nameBox.remove();
			newBox.setEnable(true);
			
			instanceBox.add(focusedObject.instanceName);
			instanceBox.setEnable(true);
			MyPrompt.write("added " + focusedObject.instanceName + " as a " + newBox.selectedLabel + " stimulus");
				
			focusedObject.removeControl();
			focusedObject.paramComboBox.reset();
			focusedObject = null;
			newBox.reset();
				
			addButton.setEnable(false);
			startButton.setEnable(true);
			
			nameBox.setEnable(true);

			if (instanceBox.length > 0)
				startButton.setEnable(true);
			else
				startButton.setEnable(false);			
		}		


	}	
}

