﻿package  
{
	import fl.controls.ColorPicker;
	import fl.controls.Label;
	import fl.controls.TextInput;
	import fl.events.ColorPickerEvent;
	import flash.events.Event;
	import flash.events.TextEvent;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author ...
	 */
	public class Gauss extends Stimulus
	{
		static private var defaultSize:Point = new Point(20, 20);
		
		private var sigmaX:ParameterControl;
		private var sigmaY:ParameterControl;
		
		private var redA:ParameterControl;
		private var greenA:ParameterControl;
		private var blueA:ParameterControl;

		private var redB:ParameterControl;
		private var greenB:ParameterControl;
		private var blueB:ParameterControl;
		
		private var amp:ParameterControl;

		private function paramCopy():void {
			
			sigmaX = paramList[0];
			sigmaY = paramList[1];
			redA = paramList[2];
			greenA = paramList[3];
			blueA = paramList[4];
			redB = paramList[5];
			greenB = paramList[6];
			blueB = paramList[7];
			amp = paramList[8];

			positionX = paramList[9];
			positionY = paramList[10];
			alphaControl = paramList[11];
			rotControl = paramList[12];
			scaleXControl = paramList[13];
			scaleYControl = paramList[14];
		}

		
		public function Gauss(name:String, cpy:Boolean = false) 
		{
			paramList = new Array();
			paramComboBox = new MyComboBox(10, 4, onParamFocus, name + "'s parameter");

			if(!cpy) {
				paramList.push(sigmaX = new ParameterControl(defaultRow, "sigmaX(t)", defaultSize.x, Number.MIN_VALUE, 1000, this));
				paramList.push(sigmaY = new ParameterControl(defaultRow, "sigmaY(t)", defaultSize.y, Number.MIN_VALUE, 1000, this));

				paramList.push(redA = new ParameterControl(defaultRow, "red_1(t)", 127, 0.0, 255, this));
				paramList.push(greenA = new ParameterControl(defaultRow, "green_1(t)", 127, 0.0, 255, this));
				paramList.push(blueA = new ParameterControl(defaultRow, "blue_1(t)", 127, 0.0, 255, this));

				paramList.push(redB = new ParameterControl(defaultRow, "red_2(t)", 255, 0.0, 255, this));
				paramList.push(greenB = new ParameterControl(defaultRow, "green_2(t)", 255, 0.0, 255, this));
				paramList.push(blueB = new ParameterControl(defaultRow, "blue_2(t)", 255, 0.0, 255, this));

				paramList.push(amp = new ParameterControl(defaultRow, "amp(t)", 1, 0.0, 1, this));
			}
			
			super(name, cpy);			

			if(!cpy)
				repaint();

		}
				
		override internal function clone(i:String):void {
			
			var cpy:Gauss = new Gauss(instanceName + i, true);
			
			for each(var v:ParameterControl in paramList) {
				cpy.paramList.push(v.clone(cpy));
			}

			cpy.paramCopy();
			Main.controlPanel.instanceBox.add(cpy.instanceName);
			
			cpy.repaint();
		}
		
		private function getColor(r:uint, g:uint, b:uint):uint {
			
			return ((r << 16) | (g << 8) | b);
		}
		
		override internal function repaint():void {
			
			step();
			
			drawGauss();
		}
		
		private function drawGauss():void {
	
			var sx:uint = sigmaX.value();
			var sy:uint = sigmaY.value();

			var rA:Number = redA.value();
			var gA:Number = greenA.value();
			var bA:Number = blueA.value();
			var rB:Number = redB.value();
			var gB:Number = greenB.value();
			var bB:Number = blueB.value();
			
			var amplitude:Number = amp.value();
			
			var rRange:Number = (rB - rA) * amplitude;
			var gRange:Number = (gB - gA) * amplitude;
			var bRange:Number = (bB - bA) * amplitude;
			

			var sx2:Number = 2 * sx * sx;
			var sy2:Number = 2 * sy * sy;
			
			for (var i:uint = 0; i < sx * 3; i++ )
				for (var j:uint = 0; j < sy * 3; j++ ) {

					var v:Number = Math.exp( -(i * i / sx2 + j * j / sy2)) * amplitude;
					var color:uint = getColor(rA + rRange * v, gA + gRange * v, bA + bRange * v);
					graphics.beginFill(color);
					graphics.drawRect(i, j, 1, 1);
					graphics.drawRect(-i-1, -j-1, 1, 1);
					graphics.drawRect(i, -j-1, 1, 1);
					graphics.drawRect(-i-1, j, 1, 1);
					graphics.endFill();
				}
			
		}
				
	}	
}
