﻿package  
{
	import fl.controls.ColorPicker;
	import fl.controls.Label;
	import fl.controls.TextInput;
	import fl.events.ColorPickerEvent;
	import flash.events.Event;
	import flash.events.TextEvent;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author ...
	 */
	public class GaussFilter extends Stimulus
	{
		static private var defaultSize:Point = new Point(20, 20);
		
		private var sigmaX:ParameterControl;
		private var sigmaY:ParameterControl;
		
		private var red:ParameterControl;
		private var green:ParameterControl;
		private var blue:ParameterControl;

		private var amp:ParameterControl;

		private function paramCopy():void {
			
			sigmaX = paramList[0];
			sigmaY = paramList[1];
			red = paramList[2];
			green = paramList[3];
			blue = paramList[4];
			amp = paramList[5];

			positionX = paramList[6];
			positionY = paramList[7];
			alphaControl = paramList[8];
			rotControl = paramList[9];
			scaleXControl = paramList[10];
			scaleYControl = paramList[11];
		}

		
		public function GaussFilter(name:String, cpy:Boolean = false) 
		{
			paramList = new Array();
			paramComboBox = new MyComboBox(10, 4, onParamFocus, name + "'s parameter");

			if(!cpy) {
				paramList.push(sigmaX = new ParameterControl(defaultRow, "sigmaX(t)", defaultSize.x, Number.MIN_VALUE, 1000, this));
				paramList.push(sigmaY = new ParameterControl(defaultRow, "sigmaY(t)", defaultSize.y, Number.MIN_VALUE, 1000, this));

				paramList.push(red = new ParameterControl(defaultRow, "red(t)", 127, 0.0, 255, this));
				paramList.push(green = new ParameterControl(defaultRow, "green(t)", 127, 0.0, 255, this));
				paramList.push(blue = new ParameterControl(defaultRow, "blue(t)", 127, 0.0, 255, this));

				paramList.push(amp = new ParameterControl(defaultRow, "amp(t)", 1, 0.0, 1, this));
			}
			
			super(name, cpy);			

			if(!cpy)
				repaint();

		}
				
		override internal function clone(i:String):void {
			
			var cpy:GaussFilter = new GaussFilter(instanceName + i, true);
			
			for each(var v:ParameterControl in paramList) {
				cpy.paramList.push(v.clone(cpy));
			}

			cpy.paramCopy();
			Main.controlPanel.instanceBox.add(cpy.instanceName);
			
			cpy.repaint();
		}
		
		private function getColor(r:uint, g:uint, b:uint):uint {
			
			return ((r << 16) | (g << 8) | b);
		}
		
		override internal function repaint():void {
			
			step();
			
			drawGaussFilter();
		}
		
		private function drawGaussFilter():void {
	
			var sx:uint = sigmaX.value();
			var sy:uint = sigmaY.value();

			var amplitude:Number = amp.value();			

			var sx2:Number = 2 * sx * sx;
			var sy2:Number = 2 * sy * sy;

			var color:uint = getColor(red.value(), green.value(), blue.value());
			
			for (var i:uint = 0; i < sx * 3; i++ )
				for (var j:uint = 0; j < sy * 3; j++ ) {

					var alfa:Number = 1 - Math.exp( -(i * i / sx2 + j * j / sy2)) * amplitude;
					graphics.beginFill(color, alfa);
					graphics.drawRect(i, j, 1, 1);
					graphics.drawRect(-i-1, -j-1, 1, 1);
					graphics.drawRect(i, -j-1, 1, 1);
					graphics.drawRect(-i-1, j, 1, 1);
					graphics.endFill();
				}
			
		}
				
	}	
}
