﻿package  
{
	import fl.controls.ColorPicker;
	import fl.controls.Label;
	import fl.controls.TextInput;
	import fl.events.ColorPickerEvent;
	import flash.events.Event;
	import flash.events.TextEvent;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author ...
	 */
	public class MyRectangle extends Stimulus
	{
		static private var defaultSize:Point = new Point(60, 60);
		
		private var sizeX:ParameterControl;
		private var sizeY:ParameterControl;
		
		private var red:ParameterControl;
		private var green:ParameterControl;
		private var blue:ParameterControl;

		private function paramCopy():void {
			
			sizeX = paramList[0];
			sizeY = paramList[1];
			red = paramList[2];
			green = paramList[3];
			blue = paramList[4];
			positionX = paramList[5];
			positionY = paramList[6];
			alphaControl = paramList[7];
			rotControl = paramList[8];
			scaleXControl = paramList[9];
			scaleYControl = paramList[10];
		}

		
		public function MyRectangle(name:String, cpy:Boolean = false) 
		{
			paramList = new Array();
			paramComboBox = new MyComboBox(10, 4, onParamFocus, name + "'s parameter");

			if(!cpy) {
				paramList.push(sizeX = new ParameterControl(defaultRow, "width(t)", defaultSize.x, 0.0, 400, this));
				paramList.push(sizeY = new ParameterControl(defaultRow, "height(t)", defaultSize.y, 0.0, 400, this));

				paramList.push(red = new ParameterControl(defaultRow, "red(t)", 255, 0.0, 255, this));
				paramList.push(green = new ParameterControl(defaultRow, "green(t)", 255, 0.0, 255, this));
				paramList.push(blue = new ParameterControl(defaultRow, "blue(t)", 255, 0.0, 255, this));

			}
			
			super(name, cpy);			

			if(!cpy)
				repaint();

		}
				
		override internal function clone(i:String):void {
			
			var cpy:MyRectangle = new MyRectangle(instanceName + i, true);
			
			for each(var v:ParameterControl in paramList) {
				cpy.paramList.push(v.clone(cpy));
			}

			cpy.paramCopy();
			Main.controlPanel.instanceBox.add(cpy.instanceName);
			
			cpy.repaint();
		}
		
		private function getColor():uint {
			var r:uint = Math.round(red.value()) << 16;
			var g:uint = Math.round(green.value()) << 8;
			var b:uint = Math.round(blue.value());
			
			return (r | g | b);
		}
		
		override internal function repaint():void {
			
			step();
			
			graphics.beginFill(getColor());
			graphics.drawRect(-sizeX.value() / 2, -sizeY.value() / 2, sizeX.value(), sizeY.value());
			graphics.endFill();
						
		}
		
	}
	
}
