﻿package
{
	import fl.controls.Label;
	import fl.controls.TextInput;
	import flash.display.Sprite;
	import flash.events.Event;
	
	/**
	 * ...
	 * @author ...
	 */
	public class ParameterControl
	{		
		static private var height:uint = 20;
		static private var width:uint = 150;
		static private var left:uint = 5;
		
		internal var label:Label;
		internal var textInput:TextInput;
		internal var calcInfix:CalcInfix;

		private var minValue:Number;
		private var maxValue:Number;
		
		private var linkObject:Stimulus;
	
		
		internal function value():Number {
			return calcInfix.eval();
		}
		
		internal function setEnable(e:Boolean):void {
			textInput.enabled = e;
		}
		
		internal function clone(newLinkObject:Stimulus):ParameterControl {

			var cpy:ParameterControl = new ParameterControl(0, label.text.substr(0, label.text.length - 3), calcInfix.eval(), minValue, maxValue, newLinkObject);
			cpy.move(label.x, label.y);
			cpy.setSize(textInput.width);
			
			cpy.textInput.text = new String(textInput.text);
			
			return cpy;
		}
		
		public function ParameterControl(row:uint, labelText:String, initValue:Number, min:Number, max:Number, linkObject:Stimulus) 
		{
			if (linkObject != null )
				linkObject.paramComboBox.add(labelText);
			this.linkObject = linkObject;
			minValue = min;
			maxValue = max;			
			calcInfix = new CalcInfix(initValue.toString(), null);

			generate(labelText);
			move(left, ControlPanel.rowToPixel(row));
			
			textInput.addEventListener(Event.CHANGE, eval);
		}
		
		internal function add():void {
			
			Main.controlPanel.addChild(label);
			Main.controlPanel.addChild(textInput);
		}

		internal function syntaxErrorCheck():Boolean {
			calcInfix = new CalcInfix(textInput.text, label.text.charAt(0));

			if (calcInfix.value.toString() == "NaN") {
				MyPrompt.write(label.text.substr(0, label.text.length - 3) + " of " + linkObject.instanceName + " contains syntax error");
				return true;
			}
			else
				return false;
		
		}

		internal function syntaxErrorCheckLight():Boolean {
			calcInfix = new CalcInfix(textInput.text, label.text.charAt(0));

			if (calcInfix.value.toString() == "NaN") {
				return true;
			}
			else
				return false;
		
		}
		
		internal function setSize(width:uint):void {
			textInput.width = width;
		}
		
		
		private function generate(text:String):void {
						
			label = new Label();
			label.text = text + " = ";
			label.width = label.text.length * 5;
			label.height = height;
			
			textInput = new TextInput();			
			textInput.x = label.width;
			textInput.width = width;
			textInput.height = height;
			textInput.text = calcInfix.targetString;
			
		}				
		
		
		internal function remove():void {
			Main.controlPanel.removeChild(label);
			Main.controlPanel.removeChild(textInput);
			
		}

		
		internal function move(px:uint, py:uint):void {
			label.x = px;
			label.y = py;
			
			textInput.y = py;
			textInput.x = px + label.width;
		}
		
		internal function eval(event:Event):void {

			calcInfix = new CalcInfix(textInput.text, label.text.charAt(0));
			
			if (calcInfix.value.toString() == "NaN") {
//				MyPrompt.write("syntax error");
			}
			else if (calcInfix.value < minValue || maxValue < calcInfix.value) {
				MyPrompt.write("out of range");
			}
			else if(linkObject != null)
				linkObject.repaint();
		}
		

	}	
}
